/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.viewer.impl;

import java.util.logging.Logger;
import java.awt.BorderLayout;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
import it.tidalwave.semantic.viewer.SemanticViewer;
import it.tidalwave.semantic.graph.impl.VisualSemanticControllerImpl;
import it.tidalwave.netbeans.visual.EnhancedSceneView;
import it.tidalwave.netbeans.visual.NodeScene;

/**
 * Top component which displays something.
 */
final class SemanticViewerTopComponent extends TopComponent implements SemanticViewer.View
  {
    private static final String PREFERRED_ID = "SemanticViewerTopComponent";
    
    private static SemanticViewerTopComponent instance;

    private final NodeScene scene;

    private final SemanticViewerControllerImpl controller;

    private SemanticViewerTopComponent()
      {
        initComponents();
        setName(NbBundle.getMessage(SemanticViewerTopComponent.class, "CTL_SemanticViewerTopComponent"));
        scene = new NodeScene();
        controller = new SemanticViewerControllerImpl(this, new VisualSemanticControllerImpl(scene));
//        pnPanel.add(scene.createView(), BorderLayout.CENTER);
        pnPanel.add(new EnhancedSceneView(scene), BorderLayout.CENTER);
      }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnToolBar = new javax.swing.JPanel();
        lbEntityViewer = new javax.swing.JLabel();
        pnPanel = new javax.swing.JPanel();

        pnToolBar.setPreferredSize(new java.awt.Dimension(406, 32));

        org.openide.awt.Mnemonics.setLocalizedText(lbEntityViewer, org.openide.util.NbBundle.getMessage(SemanticViewerTopComponent.class, "SemanticViewerTopComponent.lbEntityViewer.text")); // NOI18N

        org.jdesktop.layout.GroupLayout pnToolBarLayout = new org.jdesktop.layout.GroupLayout(pnToolBar);
        pnToolBar.setLayout(pnToolBarLayout);
        pnToolBarLayout.setHorizontalGroup(
            pnToolBarLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnToolBarLayout.createSequentialGroup()
                .addContainerGap()
                .add(lbEntityViewer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 123, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(271, Short.MAX_VALUE))
        );
        pnToolBarLayout.setVerticalGroup(
            pnToolBarLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(lbEntityViewer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 32, Short.MAX_VALUE)
        );

        pnPanel.setLayout(new java.awt.BorderLayout());

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnToolBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(pnPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(pnPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 280, Short.MAX_VALUE)
                .add(0, 0, 0)
                .add(pnToolBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lbEntityViewer;
    private javax.swing.JPanel pnPanel;
    private javax.swing.JPanel pnToolBar;
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link #findInstance}.
     */
    public static synchronized SemanticViewerTopComponent getDefault()
      {
        if (instance == null)
          {
            instance = new SemanticViewerTopComponent();
          }

        return instance;
      }

    /**
     * Obtain the SemanticViewerTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized SemanticViewerTopComponent findInstance()
      {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);

        if (win == null)
          {
            Logger.getLogger(SemanticViewerTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
          }

        if (win instanceof SemanticViewerTopComponent)
          {
            return (SemanticViewerTopComponent) win;
          }

        Logger.getLogger(SemanticViewerTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID +
                "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() 
      {
        return TopComponent.PERSISTENCE_ALWAYS;
      }

    @Override
    public void componentOpened()
      {
        // TODO add custom code on component opening
      }

    @Override
    public void componentClosed()
      {
        // TODO add custom code on component closing
      }

    @Override
    protected String preferredID()
      {
        return PREFERRED_ID;
      }
  }
